const config = require('../../config');
const providers = config.providers;
const crypto = require('crypto');
const bcrypt = require('bcrypt');
const moment = require('moment');

module.exports = function(sequelize, DataTypes) {
  const material_issue_lines = sequelize.define(
    'material_issue_lines',
    {
      id: {
        type: DataTypes.UUID,
        defaultValue: DataTypes.UUIDV4,
        primaryKey: true,
      },

quantity: {
        type: DataTypes.DECIMAL,
      
      

      },

line_status: {
        type: DataTypes.ENUM,
      
      

        values: [

"issued",


"returned",


"cancelled"

        ],

      },

line_notes: {
        type: DataTypes.TEXT,
      
      

      },

      importHash: {
        type: DataTypes.STRING(255),
        allowNull: true,
        unique: true,
      },
    },
    {
      timestamps: true,
      paranoid: true,
      freezeTableName: true,
    },
  );

  material_issue_lines.associate = (db) => {


/// loop through entities and it's fields, and if ref === current e[name] and create relation has many on parent entity





































//end loop



    db.material_issue_lines.belongsTo(db.material_issues, {
      as: 'material_issue',
      foreignKey: {
        name: 'material_issueId',
      },
      constraints: false,
    });

    db.material_issue_lines.belongsTo(db.items, {
      as: 'component_item',
      foreignKey: {
        name: 'component_itemId',
      },
      constraints: false,
    });

    db.material_issue_lines.belongsTo(db.lots, {
      as: 'lot',
      foreignKey: {
        name: 'lotId',
      },
      constraints: false,
    });

    db.material_issue_lines.belongsTo(db.locations, {
      as: 'from_location',
      foreignKey: {
        name: 'from_locationId',
      },
      constraints: false,
    });

    db.material_issue_lines.belongsTo(db.uoms, {
      as: 'uom',
      foreignKey: {
        name: 'uomId',
      },
      constraints: false,
    });




    db.material_issue_lines.belongsTo(db.users, {
      as: 'createdBy',
    });

    db.material_issue_lines.belongsTo(db.users, {
      as: 'updatedBy',
    });
  };



  return material_issue_lines;
};


